#   Author        =   @ JevinLevin
#   Description   =   Checks if the player is sprinting once they go past their checkpoint
#   Called By     =   main


# Gives the entity the temporary currentCheck tag
tag @s add currentCheck

# If the player is on level 0, then it gives them the level0 tag
tag @a[scores={level=0}] add level0
# If they are on level 0, then it increases their level to 1 temporarily
scoreboard players add @a[tag=level0] level 1

# Removes the checkpoints level from all players who arent sprinting's level
scoreboard players operation @a[tag=ingame,tag=!sprinting,dx=20,dy=20,dz=2,tag=!disableSprinting] level -= @s levelHidden
# If the players score reaches 0, then it means they had the same score as the current entity so it gives them the noCheck tag
tag @a[scores={level=0}] add noCheck
# If the player doesnt have the same score as the current entity and is in correct area, it runs the start_error function as them
execute @s ~-10 ~-10 ~4 execute @a[tag=noCheck,dx=20,dy=20,dz=2,tag=ingame,tag=!sprinting,tag=!disableSprinting] ~ ~ ~ function sprint/start_error
# Adds back the entity's level score to the player score so that it goes back to its original value
scoreboard players operation @a[tag=ingame,tag=!sprinting,tag=!noCheck,dx=20,dy=20,dz=2,tag=!disableSprinting] level += @s levelHidden
# Removes the noCheck tag which was used if the player had a score of 0
tag @a remove noCheck

# If the player started off with 0, then it removes 1 from their score so it goes back to 0
scoreboard players remove @a[tag=level0] level 1
# Also removes their tag
tag @a remove level0

# Removes the currentCheck tag
tag @s remove currentCheck