#   Author        =   @ JevinLevin
#   Description   =   Ran once the player reaches the end of the final level
#   Called By     =   main


# Teleport back to spawn
tp @s 35 34 -41 180 0

# Plays 3 sounds at the same time
# The volume is massive because of weird sound problems i keep getting, this seemed to fix it
playsound mob.enderdragon.death @s[tag=!disableSprinting,tag=ingame] 35 34 -41 1000000 
playsound block.end_portal.spawn @s[tag=!disableSprinting,tag=ingame] 35 34 -41 1000000 
playsound random.totem @s[tag=ingame] 35 34 -41 1000000 

playsound note.pling @s[tag=disableSprinting] 35 34 -41 1000000 1.5

# Shows big particle at player
particle minecraft:knockback_roar_particle 35 35 -41

# Removes the tag that checks if they are sprinting
tag @s remove sprinting

# Gives them back the lobby tag since they'll be in the lobby again
tag @s add lobby
# Gives them the win tag
tag @s[tag=!disableSprinting,tag=!skipped] add win
# If they were playing with speed, give them the fastWin tag
tag @s[tag=!disableSprinting,tag=!skipped,tag=withSpeed] add fastWin
# If they were playing with no checkpoints, give them the noCheckWin tag
tag @s[tag=!disableSprinting,tag=!skipped,tag=noCheckpoints] add noCheckWin
# If they were playing with no checkpoints and speed, give them the ultimateWin tag
tag @s[tag=!disableSprinting,tag=!skipped,tag=noCheckpoints,tag=withSpeed] add ultimateWin

title @s[tag=disableSprinting] title §l§aYou Win!
title @s[tag=disableSprinting] subtitle §aPractice Mode: Completed

# 'You Win' title in rainbow
title @s[tag=!disableSprinting] title §l§cY§6o§eu §aW§bi§9n§d!

# Subtitle for that title saying which mode they were playing on
    # Normal
    title @s[tag=!disableSprinting] subtitle §eNormal Mode: Complete
    # Speed
    title @s[tag=!disableSprinting,tag=withSpeed] subtitle §bSpeed Mode: Complete
    # No Checkpoints
    title @s[tag=!disableSprinting,tag=noCheckpoints] subtitle §cNo Checkpoints Mode: Complete
    # Ultimate
    title @s[tag=!disableSprinting,tag=withSpeed,tag=noCheckpoints] subtitle §l§cU§6L§eT§aI§bM§9A§dT§cE §6M§eO§aD§bE§9: §dC§cO§6M§eP§aL§bE§9T§dE§c!§6!§e!

# Gives the player the correct boots depending on the highest win they have ever had
    # Skipped
    replaceitem entity @s[tag=!disableSprinting,tag=skipped,tag=!fastWin,tag=!ultimateWin,tag=!noCheckWin] slot.armor.feet 1 leather_boots 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}
    # Normal
    replaceitem entity @s[tag=!disableSprinting,tag=!skipped,tag=!fastWin,tag=!ultimateWin,tag=!noCheckWin] slot.armor.feet 1 chainmail_boots 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}
    # Speed
    replaceitem entity @s[tag=!disableSprinting,tag=!skipped,tag=fastWin,tag=!ultimateWin,tag=!noCheckWin] slot.armor.feet 1 iron_boots 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}
    # No Checkpoints
    replaceitem entity @s[tag=!disableSprinting,tag=!skipped,tag=!ultimateWin,tag=noCheckWin] slot.armor.feet 1 golden_boots 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}
    # Ultimate
    replaceitem entity @s[tag=!disableSprinting,tag=!skipped,tag=ultimateWin] slot.armor.feet 1 diamond_boots 1 0 {"minecraft:item_lock":{ "mode": "lock_in_slot" }}

# Displays tellraw for all players saying which gamemode the current player just won, as well as how long it took them
    # Practice
    execute @s[tag=disableSprinting,tag=ingame] ~ ~ ~ tellraw @a { "rawtext": [{"text":"\n§l§7"},{"selector":"@s"},{"text":" has beaten the map on practice mode.\n\n"},{"text":"They took "},{"score":{"name":"@s","objective":"minutes"}},{"text":" minutes and "},{"score":{"name":"@s","objective":"seconds"}},{"text":" seconds!"} ] }
    # Skipped
    # 1 Skip
    execute @s[tag=!disableSprinting,tag=skipped,tag=ingame,scores={skipTotal=1}] ~ ~ ~ tellraw @a { "rawtext": [{"text":"\n§l§7"},{"selector":"@s"},{"text":" has beaten the map using "},{"score":{"name":"@s","objective":"skipTotal"}},{"text":" skip.\n\n"},{"text":"They took "},{"score":{"name":"@s","objective":"minutes"}},{"text":" minutes and "},{"score":{"name":"@s","objective":"seconds"}},{"text":" seconds!\n "} ] }
    # 2+ Skip
    execute @s[tag=!disableSprinting,tag=skipped,tag=ingame,scores={skipTotal=2..}] ~ ~ ~ tellraw @a { "rawtext": [{"text":"\n§l§7"},{"selector":"@s"},{"text":" has beaten the map using "},{"score":{"name":"@s","objective":"skipTotal"}},{"text":" skips in total.\n\n"},{"text":"They took "},{"score":{"name":"@s","objective":"minutes"}},{"text":" minutes and "},{"score":{"name":"@s","objective":"seconds"}},{"text":" seconds!\n "} ] }
    # Normal
    execute @s[tag=!disableSprinting,tag=!skipped,tag=ingame,tag=!withSpeed,tag=!noCheckpoints] ~ ~ ~ tellraw @a { "rawtext": [{"text":"\n§l§e"},{"selector":"@s"},{"text":" has beaten the map on normal mode!\n\n"},{"text":"They took "},{"score":{"name":"@s","objective":"minutes"}},{"text":" minutes and "},{"score":{"name":"@s","objective":"seconds"}},{"text":" seconds!\n "} ] }
    # Speed
    execute @s[tag=!disableSprinting,tag=!skipped,tag=ingame,tag=withSpeed,tag=!noCheckpoints] ~ ~ ~ tellraw @a { "rawtext": [{"text":"\n§l§b"},{"selector":"@s"},{"text":" has beaten the map with speed!\n\n"},{"text":"They took "},{"score":{"name":"@s","objective":"minutes"}},{"text":" minutes and "},{"score":{"name":"@s","objective":"seconds"}},{"text":" seconds!\n "} ] }
    # No Checkpoints
    execute @s[tag=!disableSprinting,tag=!skipped,tag=ingame,tag=noCheckpoints,tag=!withSpeed] ~ ~ ~ tellraw @a { "rawtext": [{"text":"\n§l§c"},{"selector":"@s"},{"text":" has beaten the map with no checkpoints!\n\n"},{"text":"They took "},{"score":{"name":"@s","objective":"minutes"}},{"text":" minutes and "},{"score":{"name":"@s","objective":"seconds"}},{"text":" seconds!\n "} ] }
    # Ultimate
    execute @s[tag=!disableSprinting,tag=!skipped,tag=ingame,tag=noCheckpoints,tag=withSpeed] ~ ~ ~ tellraw @a { "rawtext": [{"text":"\n§l§7"},{"selector":"@s"},{"text":" §cH§6A§eS §aB§bE§9A§dT§cE§6N §eT§aH§bE §9M§dA§cP §6O§eN §aU§bL§9T§dI§cM§6A§eT§aE §bM§9O§dD§cE§6!§e!§a!\n\n"},{"text":"§7They took "},{"score":{"name":"@s","objective":"minutes"}},{"text":" minutes and "},{"score":{"name":"@s","objective":"seconds"}},{"text":" seconds!\n "} ] }

# Displays tellraw for the current player if they played on a gamemode that can be beaten, saying what to play
# If completed on practice mode, tells them to try without
tellraw @s[tag=ingame,tag=disableSprinting] { "rawtext": [{"text":"§l§7\nComplete the without practice mode on to properly win the map.\n "} ] }
# If completed with skips, tells them to try without
tellraw @s[tag=!disableSprinting,tag=ingame,tag=skipped] { "rawtext": [{"text":"§l§7\nComplete the without using a skip for a better reward.\n "} ] }
# If completed on normal, tells them to play with speed or no checkpoints
tellraw @s[tag=!disableSprinting,tag=ingame,tag=!skipped,tag=!withSpeed,tag=!noCheckpoints,tag=!fastWin,tag=!ultimateWin,tag=!noCheckWin] { "rawtext": [{"text":"§l§e\nComplete the map again with speed or no checkpoints for a better reward!\n "} ] }
# If completed with speed, tells them to play with no checkpoints
tellraw @s[tag=!disableSprinting,tag=ingame,tag=!skipped,tag=withSpeed,tag=fastWin,tag=!ultimateWin,tag=!noCheckWin] { "rawtext": [{"text":"§l§b\nComplete the map again with no checkpoints for a better reward!\n "} ] }
# If completed with no checkpoints, then it tells them to complete with speed and no checkpoints
tellraw @s[tag=!disableSprinting,tag=ingame,tag=!skipped,tag=noCheckpoints,tag=!ultimateWin,tag=noCheckWin] { "rawtext": [{"text":"§l§c\nComplete the map with speed and no checkpoints for the ultimate reward!\n "} ] }

# Gets rid of the players nether star  and barrierjust incase
clear @s nether_star
clear @s barrier

# Removes their ingame tag as they arent playing anymore
tag @s remove ingame
# Removes their secretRoom tag if they found the secret room while completing the map, so they can find it again if they replay
tag @s remove secretRoom

# Resets their level and levelDisplay score so as it isnt needed anymore and needs to disappear from the sidebar
scoreboard players reset @s level
scoreboard players reset @s levelDisplay
# Resets the players timer for next time
scoreboard players reset @s timer

# Resets the players xp to nothing
xp -1000l @s

scoreboard players reset @s stageDeaths

tag @s remove justSkipped

tag @s remove skipped

scoreboard players reset @s skipTotal

scoreboard players reset @s timerDisplay

tag @s remove justdied
scoreboard players reset @s immune